       identification division.
       program-id.     ClientT.

       data division.
       working-storage section.
       01 PROGRAM-IDENTITY             pic x(10)  value "CLIENTT".

       01  IO-Client.
       copy ClRec.cpy  replacing ==:TAG:== by ==IO-==.

       copy CTLnk replacing ==:TAG:== by ==WS-==.

       01  ws-reponse                  pic s9(8)  comp.
       01  ws-disp-reponse             pic -9(8).


       linkage section.

       01  dfhcommarea                 pic x(32768).

       procedure division.

       principale section.

           perform a-debut

           perform b-milieu

           perform c-fin

           exec cics return end-exec

           goback
           .

       a-debut section.

           exec cics handle condition
                     error(z-error)
           end-exec

           move dfhcommarea(1:eibcalen) to ws-IO-Liens

           set ws-succes to true
           initialize ws-message-erreur
           .

       b-milieu section.

           evaluate true
               when ws-Ajout-Cl
                   perform ajouter-client
               when ws-Supp-Cl
                   perform supprimer-client
               when ws-Modif-Cl
                   perform modifier-client
               when ws-Lire-Cl
                   perform lire-client
               when other
                   move 'action inconnue' to ws-message-erreur
                   set ws-erreur to true
                   move ws-IO-Liens to dfhcommarea(1:eibcalen)
                   exec cics return end-exec
                   goback
           end-evaluate
           .

       ajouter-client section.

           exec cics write file('filea')
                           from(ws-cl-rec)
                           ridfld(ws-cl-numero)
                           resp(ws-reponse)
           end-exec.
           if ws-reponse = dfhresp(duprec)
               exec cics rewrite file('filea')
                                 from(ws-cl-rec)
                                 resp(ws-reponse)
               end-exec
           end-if
           perform control-etat
           .

       supprimer-client section.

           exec cics delete file('filea')
                            ridfld(ws-cl-numero)
                            resp(ws-reponse)
           end-exec.
           evaluate true
               when ws-reponse = dfhresp(notfnd)
                   set ws-rien to true
               when other
                   perform control-etat
           end-evaluate
           .

       modifier-client section.

           exec cics read file('filea')
                          into(IO-cl-numero)
                          ridfld(ws-cl-numero)
                          update
                          resp(ws-reponse)
           end-exec.

           if ws-reponse = dfhresp(notfnd)
               exec cics write file('filea')
                               from(ws-cl-rec)
                               ridfld(ws-cl-numero)
                               resp(ws-reponse)
               end-exec
           else
               perform control-etat
               exec cics rewrite file('filea')
                                 from(ws-cl-rec)
                                 resp(ws-reponse)
               end-exec
           end-if
           perform control-etat
           .

       lire-client section.

           exec cics read file('filea')
                          into(ws-cl-rec)
                          ridfld(ws-cl-numero)
                          resp(ws-reponse)
           end-exec.
           evaluate true
               when ws-reponse = dfhresp(notfnd)
                   set ws-Rien to true
               when other
                   perform control-etat
           end-evaluate
           .

       c-fin section.

          *> setup la commarea pour le retour via eci

           move ws-IO-Liens to dfhcommarea(1:eibcalen)
           .


       control-etat section.

           if ws-reponse not = 0
               move eibresp to ws-disp-reponse
               string 'cics erreur = '
                      ws-disp-reponse delimited by size
                   into ws-message-erreur
               end-string
               set ws-erreur to true
               move ws-IO-Liens to dfhcommarea(1:eibcalen)
               exec cics return end-exec
               goback
           end-if
           .
